'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  id: _react.PropTypes.number.isRequired,
  handleCloseBtn: _react.PropTypes.func.isRequired,
  children: _react.PropTypes.node.isRequired,
  autoCloseId: _react.PropTypes.number,
  autoCloseDelay: _react.PropTypes.number,
  handleMouseEnter: _react.PropTypes.func,
  handleMouseLeave: _react.PropTypes.func,
  type: _react.PropTypes.oneOf(Object.values(_config2.default.TYPE)),
  childrenProps: _react.PropTypes.object,
  position: _react.PropTypes.oneOf(Object.values(_config2.default.POSITION))
};

var defaultProps = {
  type: _config2.default.TYPE.DEFAULT
};

var Toast = function (_Component) {
  _inherits(Toast, _Component);

  function Toast(props) {
    _classCallCheck(this, Toast);

    var _this = _possibleConstructorReturn(this, (Toast.__proto__ || Object.getPrototypeOf(Toast)).call(this, props));

    _this.setRef = _this.setRef.bind(_this);
    _this.ref = null;
    return _this;
  }

  _createClass(Toast, [{
    key: 'setRef',
    value: function setRef(ref) {
      this.ref = ref;
    }
  }, {
    key: 'getChildren',
    value: function getChildren() {
      var props = this.props.childrenProps || {};
      return _react.Children.map(this.props.children, function (child) {
        return (0, _react.cloneElement)(child, _extends({}, props));
      });
    }
  }, {
    key: 'getToastProps',
    value: function getToastProps() {
      var _props = this.props,
          autoCloseId = _props.autoCloseId,
          autoCloseDelay = _props.autoCloseDelay,
          handleMouseEnter = _props.handleMouseEnter,
          handleMouseLeave = _props.handleMouseLeave;

      var props = {
        'data-toast-id': this.props.id,
        className: 'toastify-content toastify-content--' + this.props.type,
        ref: this.setRef
      };

      if (this.props.autoCloseId) {
        props['data-auto-close-id'] = autoCloseId;
        props['data-auto-close-delay'] = autoCloseDelay;
        props.onMouseEnter = handleMouseEnter;
        props.onMouseLeave = handleMouseLeave;
      }

      return props;
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(callback) {
      this.ref.classList.add('bounceIn--' + this.props.position, 'animated');
      callback();
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(callback) {
      this.ref.classList.remove('bounceIn--' + this.props.position, 'animated');
      this.ref.classList.add('bounceOut--' + this.props.position, 'animated');
      setTimeout(function () {
        return callback();
      }, 1000);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        this.getToastProps(),
        _react2.default.createElement(
          'button',
          {
            className: 'toastify__close',
            type: 'button',
            onClick: this.props.handleCloseBtn,
            value: this.props.id
          },
          '\xD7'
        ),
        _react2.default.createElement(
          'div',
          { className: 'toastify__body' },
          this.getChildren()
        )
      );
    }
  }]);

  return Toast;
}(_react.Component);

Toast.defaultProps = defaultProps;
Toast.propTypes = propTypes;

exports.default = Toast;